'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

if (!global.Intl) {
  // No `Intl`, so use and load the polyfill.
  global.Intl = require('intl');
}

var React = require('react');
var ReactIntl = require('react-intl');
var IntlProvider = ReactIntl.IntlProvider;
var FormattedMessage = ReactIntl.FormattedMessage;
var PropTypes = require('prop-types');

/**
 * @class TextBlockComponent
 *
 * This class will recursively interpret a textblock, thus it might hold
 * some instances of itself.
 *
 * @member {String} prefix The prefix for all control names
 * @member {String} proto The proto in use (determines if we should do index or not)
 * @member {Object} block A Textblock.
 */

var IndexBlockEditor = function (_React$Component) {
  _inherits(IndexBlockEditor, _React$Component);

  function IndexBlockEditor() {
    _classCallCheck(this, IndexBlockEditor);

    var _this = _possibleConstructorReturn(this, (IndexBlockEditor.__proto__ || Object.getPrototypeOf(IndexBlockEditor)).call(this));

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(IndexBlockEditor, [{
    key: 'handleChange',
    value: function handleChange(event) {
      var target = event.target;
      var value = target.type === 'checkbox' ? target.checked : target.value;
      var name = target.name.replace(this.props.prefix, '').substr(1).slice(0, -1);
      this.props.handleUpdate(name, value);
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.props.block.format === 'indexfeed') {
        return React.createElement(
          'fieldset',
          null,
          React.createElement('input', { type: 'hidden', value: 'indexfeed', name: this.props.prefix + '[format]' }),
          React.createElement(
            'select',
            { name: this.props.prefix + '[query]', size: '1', value: this.props.block.query,
              onChange: this.handleChange },
            React.createElement(
              'option',
              { value: 'child' },
              'Query Children (Including this page and all descendents)'
            ),
            React.createElement(
              'option',
              { value: 'parents' },
              'Query Parent Pages'
            ),
            React.createElement(
              'option',
              { value: 'dir' },
              'Directory (Only first level children)'
            )
          ),
          React.createElement(
            'select',
            { name: this.props.prefix + '[sort]', size: '1',
              value: this.props.block.sort, onChange: this.handleChange },
            React.createElement(
              'option',
              { value: 'path' },
              'In path order'
            ),
            React.createElement(
              'option',
              { value: 'changed' },
              'By most recently changed'
            ),
            React.createElement(
              'option',
              { value: 'created' },
              'By most recently created'
            )
          ),
          React.createElement(
            'div',
            { className: 'pure-g' },
            React.createElement(
              'div',
              { className: 'pure-u-1-2' },
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[navbar]', className: 'pure-checkbox' },
                React.createElement('input', { type: 'checkbox', name: this.props.prefix + '[navbar]',
                  checked: this.props.block.navbar, onChange: this.handleChange }),
                React.createElement(FormattedMessage, { id: 'NAVBAR', defaultMessage: 'Navbar' })
              ),
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[pagination]', className: 'pure-checkbox' },
                React.createElement('input', { type: 'checkbox', name: this.props.prefix + '[pagination]',
                  checked: this.props.block.pagination, onChange: this.handleChange }),
                React.createElement(FormattedMessage, { id: 'PAGINATED', defaultMessage: 'Paginated' })
              ),
              React.createElement('input', { type: 'text', value: this.props.block.child, onChange: this.handleChange,
                name: this.props.prefix + '[perPage]', disabled: !this.props.block.pagination })
            ),
            React.createElement(
              'div',
              { className: 'pure-u-1-2' },
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[monthFacet]', className: 'pure-checkbox' },
                React.createElement('input', { type: 'checkbox', name: this.props.prefix + '[monthFacet]',
                  checked: this.props.block.monthFacet, onChange: this.handleChange }),
                React.createElement(FormattedMessage, { id: 'FACETED_BY_MONTH', defaultMessage: 'Faceted By Month' })
              ),
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[tagFacet]', className: 'pure-checkbox' },
                React.createElement('input', { type: 'checkbox', name: this.props.prefix + '[tagFacet]',
                  checked: this.props.block.tagFacet, onChange: this.handleChange }),
                React.createElement(FormattedMessage, { id: 'FACETED_BY_TAG', defaultMessage: 'Faceted By Tag' })
              )
            )
          ),
          React.createElement(
            'select',
            { name: this.props.prefix + '[partial]', size: '1',
              value: this.props.block.partial, onChange: this.handleChange },
            React.createElement(
              'option',
              { value: 'card' },
              'Card'
            ),
            React.createElement(
              'option',
              { value: 'list' },
              'List'
            ),
            React.createElement(
              'option',
              { value: 'grid' },
              'Grid'
            ),
            React.createElement(
              'option',
              { value: 'masonry' },
              'Masonry'
            ),
            React.createElement(
              'option',
              { value: 'justified' },
              'Justified'
            )
          ),
          React.createElement(
            'div',
            { className: 'pure-g' },
            React.createElement(
              'div',
              { className: 'pure-u-1-2' },
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[child]' },
                React.createElement(FormattedMessage, { id: 'CHILD_PATH', defaultMessage: 'Child path' })
              ),
              React.createElement('input', { type: 'text', value: this.props.block.child, onChange: this.handleChange,
                name: this.props.prefix + '[child]' })
            ),
            React.createElement(
              'div',
              { className: 'pure-u-1-2' },
              React.createElement(
                'label',
                { htmlFor: this.props.prefix + '[proto]' },
                React.createElement(FormattedMessage, { id: 'SELECT_PROTO', defaultMessage: 'Select proto' })
              ),
              React.createElement('input', { type: 'text', value: this.props.block.proto, onChange: this.handleChange,
                name: this.props.prefix + '[proto]' })
            )
          )
        );
      }
    }
  }]);

  return IndexBlockEditor;
}(React.Component);

IndexBlockEditor.displayName = 'IndexBlockEditor';

IndexBlockEditor.propTypes = {
  block: PropTypes.shape({
    query: PropTypes.oneOf(['child', 'parents', 'dir']),
    sort: PropTypes.oneOf(['path', 'changed', 'created']),
    navbar: PropTypes.bool,
    pagination: PropTypes.bool,
    perPage: PropTypes.number,
    monthFacet: PropTypes.bool,
    tagFacet: PropTypes.bool,
    partial: PropTypes.oneOf(['card', 'grid', 'list', 'masonry', 'justified']),
    child: PropTypes.string,
    proto: PropTypes.string,
    format: PropTypes.oneOf(['indexfeed'])
  }).isRequired,
  prefix: PropTypes.string.isRequired,
  handleUpdate: PropTypes.func
};

module.exports = exports = IndexBlockEditor;