'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var Textarea = require('react-textarea-autosize').default;
var PropTypes = require('prop-types');

/**
 * @class TextBlockComponent
 *
 * This class will recursively interpret a textblock, thus it might hold
 * some instances of itself.
 *
 * @member {String} prefix The prefix for all control names
 * @member {String} proto The proto in use (determines if we should do index or not)
 * @member {Object} block A Textblock.
 */

var TextBlockEditor = function (_React$Component) {
  _inherits(TextBlockEditor, _React$Component);

  function TextBlockEditor() {
    _classCallCheck(this, TextBlockEditor);

    var _this = _possibleConstructorReturn(this, (TextBlockEditor.__proto__ || Object.getPrototypeOf(TextBlockEditor)).call(this));

    _this.handleChange = _this.handleChange.bind(_this);
    return _this;
  }

  _createClass(TextBlockEditor, [{
    key: 'handleChange',
    value: function handleChange(event) {
      var target = event.target;
      var value = target.type === 'checkbox' ? target.checked : target.value;
      var name = target.name.replace(this.props.prefix, '').substr(1).slice(0, -1);
      this.props.handleUpdate(name, value);
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.props.block.format !== 'indexfeed') {
        return React.createElement(
          'fieldset',
          null,
          React.createElement(Textarea, { name: this.props.prefix + '[source]',
            className: 'pure-input-1', placeholder: 'Posting',
            value: this.props.block.source, onChange: this.handleChange }),
          React.createElement(
            'select',
            { size: '1', name: this.props.prefix + '[format]',
              value: this.props.block.format, onChange: this.handleChange },
            React.createElement(
              'option',
              { value: 'html' },
              'HTML'
            ),
            React.createElement(
              'option',
              { value: 'markdown' },
              'Markdown'
            )
          )
        );
      }
    }
  }]);

  return TextBlockEditor;
}(React.Component);

TextBlockEditor.displayName = 'TextBlockEditor';

TextBlockEditor.propTypes = {
  block: PropTypes.shape({
    source: PropTypes.string,
    format: PropTypes.oneOf(['html', 'markdown'])
  }).isRequired,
  prefix: PropTypes.string.isRequired,
  handleUpdate: PropTypes.func
};

module.exports = exports = TextBlockEditor;